\documentclass{standalone}
\usepackage{pgfplots}
\pgfplotsset{compat=1.8}

\begin{document}
\begin{tikzpicture}

    \pgfplotstableread[col sep = comma]{./retractionManifold.csv}\dataInterpolationManifold
    
            % Manifold
    \begin{axis}[
        hide axis,
        view={120}{23},
        axis equal,
        domain= 0:360,
        y domain=0:1.25,
        % zmin=-0.5,zmax=1.5,
        ticks=none,
        clip bounding box=upper bound
        ]

        % Manifold
        \addplot3 [surf, 
                    shader=flat, 
                    draw=black, 
                    fill=white, 
                    samples= 35,
                    domain = 0:360,
                    y domain = 0:180,
                    z buffer=sort] ({cos(x)*sin(y)}, {sin(x)*sin(y)}, {cos(y)});
        % \draw [thick,black] (axis cs: 0.95, -0.7, 0.2) node [above=0.0] {$\mathcal{M}$};
        \addplot3 [very thick, blue, densely dotted] table[x index = {0}, y index = {1}, z index = {2}]{\dataInterpolationManifold};            

        % Interpolation nodes on the Manifolds
        \draw [fill, blue] (axis cs: 0, 0, 1) circle (2pt);         
        \draw [fill, blue] (axis cs:  -0.321,0.321,0.890) circle (2pt);         
        \draw [fill, blue] (axis cs: 0.597, 0.786, -0.096) circle (2pt);         
        \draw [fill, blue] (axis cs: 0.148, 0.885, -0.441) circle (2pt);  

        % Tangent space
        \addplot3 [surf, 
                    shader=flat,
                    draw=black,
                    fill=red,
                    samples = 2,
                    samples y = 2, 
                    domain= -1.0:1.4, 
                    domain y=-0.5:2.3, 
                    opacity=0.1] ({x}, {y}, {1});
        \addplot3 [mesh, 
            draw=red,
            samples = 2,
            samples y = 2, 
            domain=-1.0:1.4, 
            domain y= -0.5:2.3, 
            opacity=0.4] ({x}, {y}, {1});

        \addplot3 [domain = 0:2,
                samples = 50,
                very thick,
                densely dotted,
                red,
                samples y=1
        ] ({(+-0.175*(2+ 3*x)^3+2.5083*(2+ 3*x)^2+-10.216*(2+ 3*x)^1+14.8*(2+ 3*x)^0 - 3)/3}, {x}, {1});
        % Interpolation nodes on the Tangentspace
        \draw [fill, red] (axis cs: 0, 0, 1) circle (2pt)      ;         
        \draw [fill, red] (axis cs: -1/3, 1/3, 1) circle (2pt) ;         
        \draw [fill, red] (axis cs: 1, 4/3, 1) circle (2pt)    ;         
        \draw [fill, red] (axis cs: 1/3, 2, 1) circle (2pt)    ;         

        \draw [thick,red] (axis cs: -0.5, 1.7, 1) node[] {\footnotesize $T\mathcal{M}$};         
        \draw [thick] (axis cs: 0.8, 1.9, .4) node[] {\footnotesize $\mathcal{M}$};         

    \end{axis}
    
\end{tikzpicture}
\end{document}
